package com.yizhi.assignment.application.vo;

import com.yizhi.assignment.application.vo.entity.AssignmentFile;
import com.yizhi.assignment.application.vo.entity.AssignmentGrade;
import com.yizhi.assignment.application.vo.entity.AssignmentPoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

@Data
@Api(tags = "AssignmentSelectVo", description = "查看老师作业详细信息")
public class AssignmentSelectVo {

    @ApiModelProperty(name = "id", value = "主键id")
    private Long id;

    @ApiModelProperty(name = "name", value = "作业名称")
    private String name;

    @ApiModelProperty(name = "content", value = "内容")
    private String content;

    @ApiModelProperty(name = "", value = "老师布置得文件")
    private List<AssignmentFile> assignmentFiles;

    @ApiModelProperty(name = "finishTime", value = "作业完成时间")
    private Date finishTime;

    @ApiModelProperty(name = "amendable", value = "是否支持补交(0：否，1：是)，默认否")
    private Integer amendable;  //是否支持补交(0：否，1：是)，默认否

    @ApiModelProperty(name = "visibleRange", value = "可见范围(1：平台用户可见，2：指定学员可见)，默认平台用户可见")
    private Integer visibleRange;  //可见范围

    @ApiModelProperty(value = "是否启用提醒 1:启用 0：关闭")
    private Integer enableRemind;

    @ApiModelProperty(name = "type", value = "1打分制，2等级制")
    private Integer type;

    @ApiModelProperty(name = "listGrade", value = "如果type=2等级制度集合,如果是打分，则不写")
    private List<AssignmentGrade> listGrade;

    @ApiModelProperty(name = "listPoint", value = "可获得积分,沒有设置则不写")
    private List<AssignmentPoint> listPoint;

    @ApiModelProperty(name = "passScore", value = "合格分")
    private Integer passScore;

    @ApiModelProperty(name = "count", value = "提交次数")
    private Integer count;


    @ApiModelProperty(notes = "答案字数区间-最小值")
    private Integer answerCharaterNumMin;

    @ApiModelProperty(notes = "答案字数区间-最大值")
    private Integer answerCharaterNumMax;

    @ApiModelProperty(notes = "附件个数区间-最小值")
    private Integer answerAttachmentNumMin;

    @ApiModelProperty(notes = "附件个数区间-最大值")
    private Integer answerAttachmentNumMax;

    @ApiModelProperty(notes = "学员端是否显示评阅结果和评阅状态，0不显示，1显示")
    private Integer showRes;

    @ApiModelProperty(notes = "是否启用作业本，0否，1是")
    private Integer enableExerciseBook;

    @ApiModelProperty(notes = "关键字,逗号分隔")
    private String keywords;

    @ApiModelProperty(notes = "logo图片")
    private String image;

    @ApiModelProperty(value = "是否启用在日历任务中显示")
    private Integer enableTask;

    @ApiModelProperty(value = "日历任务设置的开始时间")
    private Date taskStartDate;

    @ApiModelProperty(value = "日历任务设置的结束时间")
    private Date taskEndDate;
}
