package com.yizhi.assignment.application.vo.apivo;

import java.util.Date;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Author: shengchenglong
 * @Date: 2018/3/7 15:58
 */
@Data
@Api(tags = "ApiAssignmentAnswersVO", description = "学员作业显示列表")
@TableName("assignment_answer")
public class ApiAssignmentAnswersVO {
    private static final long serialVersionUID = 1L;


    @ApiModelProperty(notes = "id主键")
    private Long id;

    @ApiModelProperty(notes = "作业id")
    @TableField("assignment_id")
    private Long assignmentId;

    @ApiModelProperty(notes = "账号id")
    @TableField("account_id")
    private Long accountId;

    @ApiModelProperty(notes = "分数")
    private Integer score;

    @ApiModelProperty(notes = "等级")
    private String grade;



    @ApiModelProperty(notes = "等级id")
    @TableField("grade_id")
    private Long gradeId;

    @ApiModelProperty(notes = "评阅人")
    @TableField("auditor_id")
    private Long auditorId;

    @ApiModelProperty(notes = "评阅状态(1:待阅,2:已阅)")
    private Integer status;

    @ApiModelProperty(notes = "公司id")
    @TableField("company_id")
    private Long companyId;

    @ApiModelProperty(notes = "用户名")
    @TableField("account_name")
    private String accountName;

    @ApiModelProperty(notes = "学生真实姓名")
    @TableField("real_name")
    private String real_name;

    @ApiModelProperty(notes = "站点id")
    @TableField("site_id")
    private Long siteId;

    @ApiModelProperty(notes = "部门id")
    @TableField("org_id")
    private Long orgId;

    @ApiModelProperty(notes = "创建人id")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(notes = "创建人姓名")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(notes = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(notes = "修改人id")
    @TableField(value = "update_by_id", fill = FieldFill.INSERT)
    private Long updateById;

    @ApiModelProperty(notes = "修改人姓名")
    @TableField(value = "update_by_name", fill = FieldFill.INSERT)
    private String updateByName;

    @ApiModelProperty(notes = "修改时间")
    @TableField(value = "update_time", fill = FieldFill.INSERT)
    private Date updateTime;
}
