package com.yizhi.assignment.application.vo.apivo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 学员端作业vo
 *
 * @Author: shengchenglong
 * @Date: 2018/3/8 10:49
 */
@Data
@Api(tags = {"学员端作业vo"}, description = "学员端作业vo")
public class ApiAssignmentDetailsVo implements Serializable {

    private static final long serialVersionUID = 1L;
    
    @ApiModelProperty(notes = "作业id")
    private Long id;

    @ApiModelProperty(notes = "作业名称")
    private String assignmentName;

    @ApiModelProperty(notes = "作业内容（作业要求）")
    private String assignmentContent;

    @ApiModelProperty(notes = "作业上传文件清单")
    private List<ApiFileVo> fileList;

    @ApiModelProperty(notes = "作业创建时间")
    private Date startTime;
    
    @ApiModelProperty(notes = "作业截止时间")
    private Date finishTime;
    
    @ApiModelProperty(notes="答案状态 评阅状态(1:待阅,2:已阅)")
    private Integer status;

    @ApiModelProperty(notes = "所属培训项目名称")
    private String projectName;
    
    @ApiModelProperty(notes="管理端设定的次数")
    private Integer count;
    
    @ApiModelProperty(notes="已经提交的次数")
    private Integer submitCount;

    @ApiModelProperty(notes = "合格分")
    private Integer passScore;
    
    @ApiModelProperty(notes="1显示分数 2显示等级")
    private Integer isScoreAndGrade;

    //答案
    @ApiModelProperty(notes = "答案清单(提交答案后 可能这里会有多个文件)")
    private List<ApiFileVo> answerFileList;
    
    @ApiModelProperty(notes="答案内容")
    private String answerContent;

    //批阅
    @ApiModelProperty(notes="批阅时间")
    private Date readTime;
    
    @ApiModelProperty(notes="分数")
    private Integer Score;
    
    @ApiModelProperty(notes="等级")
    private String grade;
    
    @ApiModelProperty(notes="评语")
    private String suggestion;
    
    @ApiModelProperty(notes="反馈文件")
    private List<ApiFileVo> backFileList;


    @ApiModelProperty(notes = "答案字数区间-最小值")
    private Integer answerCharaterNumMin;

    @ApiModelProperty(notes = "答案字数区间-最大值")
    private Integer answerCharaterNumMax;

    @ApiModelProperty(notes = "附件个数区间-最小值")
    private Integer answerAttachmentNumMin;

    @ApiModelProperty(notes = "附件个数区间-最大值")
    private Integer answerAttachmentNumMax;

    @ApiModelProperty(notes = "学员端是否显示评阅结果和评阅状态，0不显示，1显示")
    private Integer showRes;

    @ApiModelProperty(notes = "是否启用作业本，0否，1是")
    private Integer enableExerciseBook;

    @ApiModelProperty(notes = "提交作业的状态1，下架 ")
    private Integer isDown;

    @ApiModelProperty("提交人数")
    private Integer commitAccountNum;
}
