package com.yizhi.assignment.application.vo.apivo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 学员端作业vo
 *
 * @Author: wangfeida
 * @Date: 2018/09/07 16:40
 */
@Data
@Api(tags = {"作业详情"}, description = "作业详情")
public class ApiAssignmentVO implements Serializable {

    private static final long serialVersionUID = 1L;
    
    @ApiModelProperty(notes = "作业id")
    private Long id;

    @ApiModelProperty(notes = "作业名称")
    private String assignmentName;
    
    @ApiModelProperty(notes = "所属培训项目名称")
    private String projectName;

    @ApiModelProperty(notes = "作业截止时间")
    private Date finishTime;

    @ApiModelProperty(notes="管理端设置次数")
    private Integer count;

    @ApiModelProperty(notes="是否允许补交amendable是否支持补交(0：否，1：是） ")
    private Integer amendable;

    @ApiModelProperty(notes="合格分")
    private Integer passScore;
    
    @ApiModelProperty(notes = "作业内容（作业要求）")
    private String assignmentContent;

    @ApiModelProperty(notes = "作业上传文件清单")
    private List<ApiFileVo> fileList;

    @ApiModelProperty(notes="学员已经提交的次数")
    private Integer submitCount;


    @ApiModelProperty(notes = "答案字数区间-最小值")
    private Integer answerCharaterNumMin;

    @ApiModelProperty(notes = "答案字数区间-最大值")
    private Integer answerCharaterNumMax;

    @ApiModelProperty(notes = "附件个数区间-最小值")
    private Integer answerAttachmentNumMin;

    @ApiModelProperty(notes = "附件个数区间-最大值")
    private Integer answerAttachmentNumMax;

    @ApiModelProperty(notes = "学员端是否显示评阅结果和评阅状态，0不显示，1显示")
    private Integer showRes;

    @ApiModelProperty(notes = "是否启用作业本，0否，1是")
    private Integer enableExerciseBook;

    @ApiModelProperty("提交人数")
    private Integer commitAccountNum;
}
