package com.yizhi.assignment.application.vo.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 老师布置作业的主表
 * </p>
 *
 * @author 王飞达123
 * @since 2018-03-08
 */
@Data
@Api(tags = "Assignment", description = "老师布置作业的主表")

public class Assignment{

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(notes = "id主键")
    private Long id;

    @ApiModelProperty(notes = "所属项目id，未关联则为0")
    
    private Long trainingProjectId;

    @ApiModelProperty(notes = "冗余培训项目名称")
    
    private String trainingProjectName;

    @ApiModelProperty(notes = "作业序号")
    
    private Long serialNum;

    @ApiModelProperty(notes = "作业名称")
    private String name;

    @ApiModelProperty(value = "是否启用提醒 1:启用 0：关闭")
    
    private Integer enableRemind;

    @ApiModelProperty(notes = "是否支持补交(0：否，1：是)，默认否")
    private Integer amendable;

    @ApiModelProperty(notes = "可见范围(1：平台用户可见，2：指定学员可见)，默认平台用户可见")
    
    private Integer visibleRange;
    

    @ApiModelProperty(notes = "作业完成时间")
    
    private Date finishTime;

    @ApiModelProperty(notes = "状态(1：草稿，2：上架，3：下架,0删除)")
    private Integer status;

    @ApiModelProperty(notes = "可以提交的次数")
    private Integer count;
    
    @ApiModelProperty(notes = "合格分")
    
    private Integer passScore;
    
    
    
    @ApiModelProperty(name="type",value="1打分制，2等级制",required=true)
	private Integer type;
    

    @ApiModelProperty(notes = "上架时间")
    
    private Date addedTime;


    @ApiModelProperty(notes = "公司id")
    
    private Long companyId;

    @ApiModelProperty(notes = "站点id")
    
    private Long siteId;

    @ApiModelProperty(notes = "部门id")
    
    private Long orgId;

    @ApiModelProperty(notes = "创建人id")
    
    private Long createById;

    @ApiModelProperty(notes = "创建人姓名")
    
    private String createByName;

    @ApiModelProperty(notes = "创建时间")
    
    private Date createTime;

    @ApiModelProperty(notes = "修改人id")
    
    private Long updateById;

    @ApiModelProperty(notes = "修改人姓名")
    
    private String updateByName;

    @ApiModelProperty(notes = "修改时间")
    
    private Date updateTime;

    @ApiModelProperty(notes = "答案字数区间-最小值")
    
    private Integer answerCharaterNumMin;

    @ApiModelProperty(notes = "答案字数区间-最大值")
    
    private Integer answerCharaterNumMax;

    @ApiModelProperty(notes = "附件个数区间-最小值")
    
    private Integer answerAttachmentNumMin;

    @ApiModelProperty(notes = "附件个数区间-最大值")
    
    private Integer answerAttachmentNumMax;

    @ApiModelProperty(notes = "学员端是否显示评阅结果和评阅状态，0不显示，1显示")
    
    private Integer showRes;

    @ApiModelProperty(notes = "是否启用作业本，0否，1是")
    
    private Integer enableExerciseBook;

    @ApiModelProperty(notes = "关键字,逗号分隔")
    
    private String keywords;

    @ApiModelProperty(notes = "logo图片")
    private String image;

    @ApiModelProperty(value = "是否启用在日历任务中显示")
    
    private Integer enableTask;

    @ApiModelProperty(value = "日历任务设置的开始时间")
    
    private Date taskStartDate;

    @ApiModelProperty(value = "日历任务设置的结束时间")
    
    private Date taskEndDate;


}
