package com.yizhi.assignment.application.vo.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 学员对作业回复可以是文件，存放学员的作业回复的文件的地址
 * </p>
 *
 * @author 王飞达123
 * @since 2018-03-08
 */
@Data
@Api(tags = "AssignmentAnswerFile", description = "学员对作业回复可以是文件，存放学员的作业回复的文件的地址")
@TableName("assignment_answer_file")
public class AssignmentAnswerFile extends Model<AssignmentAnswerFile> {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(notes = "id主键")
    private Long id;

    @ApiModelProperty(notes = "作业答案id")
    @TableField("anwser_id")
    private Long anwserId;

    @ApiModelProperty(notes = "文件类型(1:作业答案,2:评阅回复)")
    private Integer type;

    @ApiModelProperty(notes = "文件存放路径")
    @TableField("file_url")
    private String fileUrl;

    @ApiModelProperty(notes = "源文件名")
    @TableField("file_name")
    private String fileName;

    @ApiModelProperty(notes = "后缀名")
    private String suffix;
    
    @ApiModelProperty(notes = "文件大小")
    private String size;
    
    @ApiModelProperty(notes = "如果是评阅回复，则转换为png格式")
    private String png;

    @ApiModelProperty(notes = "创建人id")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(notes = "创建人姓名")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(notes = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @TableField("video_ld")
    private String videoLd;

    @TableField("video_sd")
    private String videoSd;

    @TableField("video_hd")
    private String videoHd;

    @ApiModelProperty(notes = "是否是视频文件，0否，1是")
    @TableField(value = "is_video")
    private Integer isVideo;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
