package com.yizhi.assignment.application.vo.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 *
 * </p>
 *
 * @author shengchenglong123
 * @since 2019-10-22
 */
@Data
@Api(tags = "AssignmentAnswerTipoff", description = "")
@TableName("assignment_answer_tipoff")
public class AssignmentAnswerTipoff extends Model<AssignmentAnswerTipoff> {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "作业答案id")
    @TableField("assignment_answer_id")
    private Long assignmentAnswerId;

    @ApiModelProperty(value = "举报原因")
    private String content;

    @ApiModelProperty(value = "举报图片")
    @TableField("img_url")
    private String imgUrl;

    private String company;

    @ApiModelProperty(value = "创建人id")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建人姓名")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "处理状态，0，提交状态（待处理）；1 移除（不显示再列表）s")
    private Integer status;

    @ApiModelProperty(value = "处理人id")
    @TableField("auditor_id")
    private Long auditorId;

    @ApiModelProperty(value = "处理意见")
    @TableField("audit_content")
    private String auditContent;

    @ApiModelProperty(value = "处理时间")
    @TableField("audit_time")
    private Date auditTime;

    @TableField("is_new")
    private Integer isNew;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
