package com.yizhi.application.controller.api;

import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.application.mapper.AssignmentMapper;
import com.yizhi.util.application.num.NumUtil;
import com.yizhi.assignment.application.vo.MinimbaAssignmentVO;
import com.yizhi.assignment.application.vo.MinimbaStudyRecordVO;
import com.yizhi.assignment.application.vo.MinimbaUserDetailParamVO;
import com.yizhi.assignment.application.vo.MinimbaUserDetailVO;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author: ding
 * @Date: 2019/10/24
 */
@RequestMapping("/assignment/minimba")
@RestController(value = "MinimbaControllerRemote")
public class MinimbaController {

    private static final Logger logger = LoggerFactory.getLogger(MinimbaController.class);

    @Autowired
    private AssignmentMapper assignmentMapper;


    @PostMapping("/userDetails")
    public MinimbaUserDetailVO getUserDetails(@RequestBody MinimbaUserDetailParamVO paramVO) {
        paramVO.getIsRealTime();
        RequestContext context = ContextHolder.get();

        MinimbaUserDetailVO vo = assignmentMapper.userDetail(paramVO, context.getSiteId(), context.getCompanyId(), context.getAccountId());
        int allNum = assignmentMapper.selectCountAllPlan(paramVO);
        int finishedNum = assignmentMapper.selectCountFinishedPlan(context.getAccountId(), paramVO);
        String percentage = NumUtil.getPercentage(finishedNum, allNum, 0);
        int res = Integer.parseInt(percentage.replace("%", ""));
        vo.setPercentage(res);
        return vo;
    }

    @GetMapping("/studyingRecords")
    public List<MinimbaStudyRecordVO> getProjectStudyingRecords(Long projectId) {
        List<MinimbaStudyRecordVO> vos = assignmentMapper.getMinimbaStudyRecordVO(projectId);
        List<MinimbaStudyRecordVO> resultList = new ArrayList<>();

        RequestContext res = ContextHolder.get();
        if (CollectionUtils.isNotEmpty(vos)) {
            vos.forEach(vo -> {
//                vo.setCourseScore(assignmentMapper.selectScore(vo.getCourseId()));
//                vo.setCourseStudyDuration(String.valueOf(assignmentMapper.selectSeconds(vo.getCourseId())));
                List<MinimbaAssignmentVO> assignmentVOList = assignmentMapper.getMinimbaAssignmentVO(vo.getPlanId(), res.getAccountId());
                Long examId = assignmentMapper.getPlanExamId(vo.getPlanId());
                vo.setExamId(examId);
                if (CollectionUtils.isNotEmpty(assignmentVOList)) {
                    vo.setAssignmentAnswerList(assignmentVOList);
                    resultList.add(vo);
                }
            });
        }
        return resultList;
    }
}

