package com.yizhi.application.controller.remote;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.assignment.application.vo.PdfPages;
import com.yizhi.comment.application.vo.domain.PdfPagesVo;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.application.entity.AssignmentAnswer;
import com.yizhi.application.entity.AssignmentAnswerThumb;
import com.yizhi.application.entity.AssignmentAnswerTipoff;
import com.yizhi.application.entity.AssignmentComment;
import com.yizhi.comment.application.feign.PdfPagesClient;
import com.yizhi.application.mapper.AssignmentAnswerFileMapper;
import com.yizhi.application.mapper.AssignmentAnswerMapper;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.application.service.AssignmentAnswerFileService;
import com.yizhi.application.service.AssignmentAnswerThumbService;
import com.yizhi.system.application.system.remote.AccountClient;
import com.yizhi.util.application.constant.TpActivityType;
import com.yizhi.system.application.vo.AccountVO;
import com.yizhi.assignment.application.vo.AssignmentStudentExerciseBookListVO;
import com.yizhi.assignment.application.vo.apivo.ApiAssignmentCommentVO;
import com.yizhi.assignment.application.vo.apivo.ApiFileVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @ClassName AssignmentExpriceBookController
 * @Description TODO
 * @Author shengchenglong
 * @DATE 2019-10-22 11:15
 * @Version 1.0
 */
@Api("作业本--学员端")
@RestController
@RequestMapping("/remote/api/assignment/exerciseBook")
public class ApiAssignmentExerciseBookController {

    @Autowired
    private AssignmentAnswerMapper assignmentAnswerMapper;
    @Autowired
    private AssignmentAnswerFileMapper assignmentAnswerFileMapper;
    @Autowired
    private AssignmentAnswerThumbService assignmentAnswerThumbService;
    @Autowired
    private AssignmentAnswerFileService assignmentAnswerFileService;
    @Autowired
    private AccountClient accountClient;
    @Autowired
    private IdGenerator idGenerator;

    @Autowired
    private PdfPagesClient pdfPagesClient;

    @GetMapping("/page")
    @ApiOperation("作业本列表(每个人对改作业提交的答案)")
    public Page<AssignmentStudentExerciseBookListVO> list(
            @ApiParam("作业id") @RequestParam("assignmentId") Long assignmentId,
            @ApiParam("要跳转的页数") @RequestParam(name = "pageNo", defaultValue = "1") int pageNo,
            @ApiParam("每页条数，默认：10") @RequestParam(name = "pageSize", defaultValue = "10") int pageSize) {

        AssignmentAnswer answerObj = new AssignmentAnswer();
        answerObj.setAssignmentId(assignmentId);
        answerObj.setIsDown(0);
        answerObj.setDeleted(0);

        EntityWrapper<AssignmentAnswer> ew = new EntityWrapper<>(answerObj);
        ew.orderBy("create_time", false);

        // 提交次数 查询实体工具 obj
        AssignmentAnswer answerObjForCommitTimes = new AssignmentAnswer();
        answerObjForCommitTimes.setAssignmentId(assignmentId);
        // 点赞次数 查询实体工具 obj
        AssignmentAnswerThumb assignmentAnswerThumbObj = new AssignmentAnswerThumb();
        assignmentAnswerThumbObj.setIsThumb(1);


        Page<AssignmentAnswer> page = new Page<>(pageNo, pageSize);

        page = answerObj.selectPage(page, ew);
        if (page != null && CollectionUtils.isNotEmpty(page.getRecords())) {
            List<AssignmentAnswer> answers = page.getRecords();

            Page<AssignmentStudentExerciseBookListVO> resultPage = new Page<>(pageNo, pageSize);
            resultPage.setTotal(page.getTotal());
            List<AssignmentStudentExerciseBookListVO> resultVos = new ArrayList<>();

            answers.forEach(answer -> {
                AssignmentStudentExerciseBookListVO vo = new AssignmentStudentExerciseBookListVO();

                vo.setAssignmentAnswerId(answer.getId());
                answerObjForCommitTimes.setAccountId(answer.getAccountId());
                vo.setCommitNum(answerObjForCommitTimes.selectCount(new EntityWrapper(answerObjForCommitTimes)));
                vo.setCommitTime(answer.getCreateTime());
                vo.setContent(answer.getContent());

                assignmentAnswerThumbObj.setAssignmentAnswerId(answer.getId());
                vo.setThumbpsTimes(assignmentAnswerThumbService.selectCount(new EntityWrapper<>(assignmentAnswerThumbObj)));

                assignmentAnswerThumbObj.setAccountId(ContextHolder.get().getAccountId());
                vo.setHasThumbUp(assignmentAnswerThumbService.selectCount(new EntityWrapper<>(assignmentAnswerThumbObj)) > 0);
                List<ApiFileVo> fileList = assignmentAnswerFileMapper.listAssignmentAnswerFile(answer.getId(), 1);
                try {
					fileList.forEach(file -> {
                        exechangePages(file);
                        /*List<PdfPages> list = pdfPagesClient.list(file.getId(), TpActivityType.TYPE_ASSIGNMENT);
						if (CollectionUtils.isNotEmpty(list)) {
							file.setPdfPages(list);
						}*/
					});
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
                vo.setFileVos(fileList);

                AccountVO accountVO = getAccount(answer.getAccountId());
                if (accountVO != null) {
                    vo.setAccountName(StringUtils.isEmpty(accountVO.getFullName()) ? accountVO.getName() : accountVO.getFullName());
                    vo.setHeadPortrait(accountVO.getHeadPortrait());
                }

                resultVos.add(vo);

                assignmentAnswerThumbObj.setAssignmentAnswerId(null);
                assignmentAnswerThumbObj.setAccountId(null);
            });
            resultPage.setRecords(resultVos);
            return resultPage;
        }
        return new Page<>(pageNo, pageSize);
    }

    private void exechangePages(ApiFileVo file) {
        List<PdfPagesVo> list1 = pdfPagesClient.list(file.getId(), TpActivityType.TYPE_ASSIGNMENT);
        if (CollectionUtils.isNotEmpty(list1)) {
            List<PdfPages> list = new ArrayList<>();
            list1.forEach(pdfPages -> {
                PdfPages pages = new PdfPages();
                BeanUtils.copyProperties(pdfPages,pages);
                list.add(pages);
            });
            file.setPdfPages(list);
        }
    }

    @GetMapping("/thumbUp")
    public boolean thumbup(@RequestParam("assignmentAnswerId") Long assignmentAnswerId,
                           @RequestParam("isThumbUp") boolean isThumbUp) {
        AssignmentAnswerThumb assignmentAnswerThumbObj = new AssignmentAnswerThumb();

        assignmentAnswerThumbObj.setAccountId(ContextHolder.get().getAccountId());
        assignmentAnswerThumbObj.setAssignmentAnswerId(assignmentAnswerId);

        AssignmentAnswerThumb oldOne = assignmentAnswerThumbObj.selectOne(new EntityWrapper(assignmentAnswerThumbObj));

        if (oldOne != null) {
//            assignmentAnswerThumbObj = new AssignmentAnswerThumb();
            assignmentAnswerThumbObj.setIsThumb(isThumbUp ? 1 : 0);
            assignmentAnswerThumbObj.setId(oldOne.getId());

            return assignmentAnswerThumbObj.updateById();
        }
        assignmentAnswerThumbObj.setId(idGenerator.generate());
        assignmentAnswerThumbObj.setCreateTime(new Date());
        return assignmentAnswerThumbObj.insert();
    }

    @GetMapping("/comment/page")
    @ApiOperation("评论列表")
    public Page<ApiAssignmentCommentVO> commentPage(
            @RequestParam("assignmentAnswerId") Long assignmentAnswerId,
            @ApiParam("要跳转的页数") @RequestParam(name = "pageNo", defaultValue = "1") int pageNo,
            @ApiParam("每页条数，默认：10") @RequestParam(name = "pageSize", defaultValue = "10") int pageSize
    ) {
        Page<AssignmentComment> page = new Page(pageNo, pageSize);

        AssignmentComment comment = new AssignmentComment();
        comment.setAuditStatus(0);
        comment.setDeleted(0);
        comment.setAssignmentAnswerId(assignmentAnswerId);

        EntityWrapper<AssignmentComment> ew = new EntityWrapper<>(comment);
        ew.orderBy("create_time", false);
        page = comment.selectPage(page, ew);

        if (page != null && CollectionUtils.isNotEmpty(page.getRecords())) {
            List<ApiAssignmentCommentVO> vos = new ArrayList<>();
            page.getRecords().forEach(item -> {
                ApiAssignmentCommentVO vo = new ApiAssignmentCommentVO();
                vo.setCommentId(item.getId());
                vo.setContent(item.getContent());
                vo.setCreateTime(item.getCreateTime());
                AccountVO accountVO = getAccount(item.getCreateById());
                if (accountVO != null) {
                    vo.setCreateByName(StringUtils.isEmpty(accountVO.getFullName()) ? accountVO.getName() : accountVO.getFullName());
                }
                if (item.getParentCreateById() != null) {
                    accountVO = getAccount(item.getParentCreateById());
                    if (accountVO != null) {
                        vo.setParentCreateByName(StringUtils.isEmpty(accountVO.getFullName()) ? accountVO.getName() : accountVO.getFullName());
                    }
                }
                vos.add(vo);
            });

            Page<ApiAssignmentCommentVO> resultPage = new Page<>(pageNo, pageSize);
            resultPage.setTotal(page.getTotal());
            resultPage.setRecords(vos);
            return resultPage;
        }
        return new Page<>(pageNo, pageSize);
    }

    @GetMapping("/comment/add")
    @ApiOperation("进行评论")
    public Boolean commentAdd(
            @RequestParam("assignmentAnswerId") Long assignmentAnswerId,
            @RequestParam(name = "parentCommentId", required = false) Long parentCommentId,
            @RequestParam("content") String content

    ) {
        AssignmentComment comment = new AssignmentComment();
        comment.setAssignmentAnswerId(assignmentAnswerId);
        comment.setCompanyId(ContextHolder.get().getCompanyId());
        comment.setContent(content);
        comment.setCreateById(ContextHolder.get().getAccountId());
        comment.setCreateByName(ContextHolder.get().getAccountName());
        comment.setId(idGenerator.generate());
        comment.setOrgId(ContextHolder.get().getOrgId());
        if (parentCommentId != null) {
            AssignmentComment parent = new AssignmentComment();
            parent.setId(parentCommentId);
            parent = parent.selectById();
            if (parent != null) {
                comment.setParentId(parentCommentId);
                comment.setParentCreateById(parent.getCreateById());
            }
        }
        comment.setCreateTime(new Date());
        comment.setSiteId(ContextHolder.get().getSiteId());
        return comment.insert();
    }

    @PostMapping("/tipoff")
    public Boolean tipoff(@RequestBody AssignmentAnswerTipoff record) {
        record.setId(idGenerator.generate());
        record.setCreateById(ContextHolder.get().getAccountId());
        record.setCreateByName(ContextHolder.get().getAccountName());
        record.setCreateTime(new Date());
        record.setIsNew(1);
        return record.insert();
    }

    private AccountVO getAccount(long accountId) {
        AccountVO accountVO = accountClient.findById(accountId);
        return accountVO;
    }
}
