package com.yizhi.application.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 老师布置作业的主表
 * </p>
 *
 * @author 王飞达123
 * @since 2018-03-08
 */
@Data

@TableName("assignment")
public class Assignment extends Model<Assignment> {

    private static final long serialVersionUID = 1L;


    
    private Long id;

    
    @TableField("training_project_id")
    private Long trainingProjectId;

    
    @TableField("training_project_name")
    private String trainingProjectName;

    
    @TableField("serial_num")
    private Long serialNum;

    
    private String name;

    
    @TableField("enable_remind")
    private Integer enableRemind;

    
    private Integer amendable;

    
    @TableField("visible_range")
    private Integer visibleRange;
    

    
    @TableField("finish_time")
    private Date finishTime;

    
    private Integer status;

    
    private Integer count;
    
    
    @TableField("pass_score")
    private Integer passScore;
    
    
    
    
	private Integer type;
    

    
    @TableField("added_time")
    private Date addedTime;


    
    @TableField("company_id")
    private Long companyId;

    
    @TableField("site_id")
    private Long siteId;

    
    @TableField("org_id")
    private Long orgId;

    
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    
    @TableField(value = "update_by_id", fill = FieldFill.INSERT)
    private Long updateById;

    
    @TableField(value = "update_by_name", fill = FieldFill.INSERT)
    private String updateByName;

    
    @TableField(value = "update_time", fill = FieldFill.INSERT)
    private Date updateTime;

    
    @TableField("answer_charater_num_min")
    private Integer answerCharaterNumMin;

    
    @TableField("answer_charater_num_max")
    private Integer answerCharaterNumMax;

    
    @TableField("answer_attachment_num_min")
    private Integer answerAttachmentNumMin;

    
    @TableField("answer_attachment_num_max")
    private Integer answerAttachmentNumMax;

    
    @TableField("show_res")
    private Integer showRes;

    
    @TableField("enable_exercise_book")
    private Integer enableExerciseBook;

    
    @TableField("keywords")
    private String keywords;

    
    private String image;

    
    @TableField("enable_task")
    private Integer enableTask;

    
    @TableField("task_start_date")
    private Date taskStartDate;

    
    @TableField("task_end_date")
    private Date taskEndDate;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
