package com.yizhi.application.service;

import com.baomidou.mybatisplus.service.IService;
import com.yizhi.application.entity.AssignmentAnswerFile;

import java.util.List;

/**
 * <p>
 * 学员对作业回复可以是文件，存放学员的作业回复的文件的地址 服务类
 * </p>
 *
 * @author 王飞达123
 * @since 2018-03-08
 */
public interface AssignmentAnswerFileService extends IService<AssignmentAnswerFile> {
    /*
     *//**
     * 查询学生对应作业的文件
     *
     * @param assignmentId
     * @return
     *//*
    List<AssignmentAnswerFile> listByAssignmentIdAndAccountId(@Param("assignmentId") Long assignmentId, RequestContext context);*/

    /**
     * @param id 作业答案的id
     * @return 作业答案对应具体对象
     */
    List<List<AssignmentAnswerFile>> selectAssignmentAnswerFileById(List<Long> id);


    List<AssignmentAnswerFile> listAssignmentAnswerFile(Long id);

    List<AssignmentAnswerFile> listAssignmentAnswerBackFile(Long id);

    /**
     * 如果是第二次批阅，先干掉第一次批阅文件
     */
    Boolean deleteAnswerFile(Long assignmentId);

    /**
     * 根据老师或者学生得到学生提交的文件/老师的反馈文件
     *
     * @param answerId
     * @return
     */
    List<AssignmentAnswerFile> listGetAssignmentAnswerFile(Long answerId, Integer type);

    /**
     * 确认文件是视屏文件
     *
     * @param ids
     * @return
     */
    Integer verifyVideo(List<Long> ids);
}
